﻿* Memo fields, text file limits and increasing EditBox size test results

#include <hmg.ch>

#include "DBV_Test.ch"

PROCEDURE Main()

   SET CENT ON    
   SET DATE GERM
   SET TOOLTIPSTYLE BALLOON

	DEFINE WINDOW frmDBVTest ;
		AT 0,0 ;
		WIDTH 640 ;
		HEIGHT 510 ;
		TITLE 'Test DBF Validation' ;
		MAIN 
      
      ON KEY ESCAPE OF frmDBVTest ACTION ThisWindow.Release
      
		DEFINE MAIN MENU
			DEFINE POPUP '&File'
            ITEM 'Select File'   NAME mitSelFile ACTION SelectFile()
            SEPARATOR
            ITEM "E&xit"  ACTION ThisWindow.Release
			END POPUP      
		END MENU // MAIN
            
      DEFINE STATUSBAR FONT 'Verdana' SIZE 8
          STATUSITEM ""
          STATUSITEM ""
          DATE WIDTH 80
          CLOCK WIDTH 90
      END STATUSBAR
         	
   END WINDOW
   
	CENTER   WINDOW frmDBVTest
	ACTIVATE WINDOW frmDBVTest

RETURN // DBValidTest.Main()

*._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-

PROC SelectFile()

   LOCAL nDBValdCode  := 0,;
         nDBFileType  := 0,;
         cDBFileType  := '',;
         nErrorCode   := 0,;
         nDBVMsgCode  := 0,;
         cDBTstResult := '',;
         cResultMsg   := '',;
         cSelFName    := ''

   cSelFName := Getfile( { {'dataBase (.dbf) Files','*.dbf'} },;     // acFilter
                    'Select File' ,;                             // Title  
                    GetStartUpFolder(),;                        // cDefaultPath 
                    .F.,;                                       // lMultiSelect 
                    .T. )                                      // lNoChangeCurrDir
                    
   IF !EMPTY( cSelFName )
   
      frmDBVTest.StatusBar.Item( 1 ) := cSelFName
      frmDBVTest.StatusBar.Item( 2 ) := TTrim( FILESIZE( cSelFName ) ) + " bytes"
      
      nDBValdCode := HL_DBFValid( cSelFName )
      
      IF nDBValdCode # 0   
         nDBVMsgCode := ASCAN( aDBVCMsgs, { | a1 | a1[ 1 ] = nDBValdCode }  )         
         IF nDBValdCode > 0  
            IF nDBVMsgCode > 0  // Defined File type      
               cTableType := aDBVCMsgs[ nDBVMsgCode, 2]
            ELSE
               cTableType := "Unrecognized table type"
            ENDIF   
            cResultMsg := "A valid table in type " + cTableType
         ELSE  // nDBValdCode < 0 :  Not valid table         
            IF nDBVMsgCode > 0  // Defined error type
               IF nDBValdCode < -0xFF 
                  cResultMsg := "A low level file error occured " + cDBTstResult
               ELSE
                  IF nDBValdCode > -0xFF 
                     cResultMsg := aDBVCMsgs[ nDBVMsgCode, 2]
                  ELSE   
                     cResultMsg := "Undefined Error type"               
                  ENDIF   
               ENDIF         
            ELSE
               nDBFileType := ASCAN( aDBVCMsgs, { | a1 | a1[ 1 ] = -nDBValdCode }  )
               IF nDBFileType > 0
                  cDBFileType := aDBVCMsgs[ nDBFileType, 2]
               ELSE
                  cDBFileType := "Unrecognized dbf type with memo" 
               ENDIF                   
               cResultMsg  := "A valid table in type " + cDBFileType + CRLF2 +  ;
                            "BUT : MEMO FILE NOT FOUND !"            
            ENDIF nDBVMsgCode < 0       
         ENDIF nDBValdCode > 0   
      ELSE  // nDBValdCode = 0
         cResultMsg := "Unidentified file type, highly probably a none .dbf file."
      ENDIF nDBValdCode # 0 
      MsgBox( cResultMsg, "DBF Validity check Result" )
   * ELSE  : file name not specified / selected
   ENDIF
      
RETU // SelectFile()
                    
*._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-._.-
